﻿<%
    Dim oDBConn As OleDbConnection
    Dim oDBReader As OleDbDataReader
    Dim oDBCmd As OleDbCommand
    Dim sMACAddr As String
    Dim sAppliance As String
    Dim lActual As Long
    Dim sActual As String
    Dim dtAppliances As DataTable = New DataTable("Appliances")
    Dim dcAppliance As DataColumn = New DataColumn("Appliance")
    Dim dcActual As DataColumn = New DataColumn("Actual")
    Dim drRow As DataRow
    Dim dataView As DataView
    Dim drvView As DataRowView
    Dim hs As Object
    Dim aVisifire() As String = {"SL.Visifire.Charts.xap", "Visifire2.js"}
    Dim sComponent As String
    Dim bVisifire = True
    Dim myXAML As String
    
    ' Initialize Homeseer interface
    hs = Context.Items("Content")

    If Not hs Is Nothing Then
        ' Check availability Visifire components
        For Each sComponent In aVisifire
            If Not File.Exists(hs.GetAppPath & "/html/Plugwise/" & sComponent) Then
                myXAML = "<br /><br />The Visifire -" & sComponent & "- component is not available<br>" + vbNewLine
                bVisifire = False
            End If
        Next
        If bVisifire = True Then
            dcAppliance.DataType = System.Type.GetType("System.String")
            dcActual.DataType = System.Type.GetType("System.Int32")
            dtAppliances.Columns.Add(dcAppliance)
            dtAppliances.Columns.Add(dcActual)

            oDBConn = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & hs.GetAppPath & "\Data\Plugwise\plugwise.mdb")
            oDBConn.Open()
            
            myXAML = "<vc:Chart xmlns:vc=""clr-namespace:Visifire.Charts;assembly=SLVisifire.Charts"" Width=""700"" Height=""500"" BorderThickness=""0"" Theme=""Theme1"" Watermark=""False"" ScrollingEnabled=""False"" AnimationEnabled=""False"">" + vbNewLine
            myXAML = myXAML + "<vc:Chart.Titles>" + vbNewLine
            myXAML = myXAML + "<vc:Title Text=""Actual usage per appliance"" />" + vbNewLine
            myXAML = myXAML + "</vc:Chart.Titles>" + vbNewLine
            myXAML = myXAML + "<vc:Chart.AxesX>" + vbNewLine
            myXAML = myXAML + "<vc:Axis Title=""Appliances"" />" + vbNewLine
            myXAML = myXAML + "</vc:Chart.AxesX>" + vbNewLine
            myXAML = myXAML + "<vc:Chart.AxesY>" + vbNewLine
            myXAML = myXAML + "<vc:Axis Title=""Usage (W)"" />" + vbNewLine
            myXAML = myXAML + "</vc:Chart.AxesY>" + vbNewLine
            myXAML = myXAML + "<vc:Chart.Series>" + vbNewLine
            myXAML = myXAML + "<vc:DataSeries RenderAs=""Bar"" AxisYType=""Primary"">" + vbNewLine
            myXAML = myXAML + "<vc:DataSeries.DataPoints>" + vbNewLine

            ' Query the database and collect the required data
            oDBCmd = New OleDbCommand("SELECT DISTINCT s.macaddress, a.description FROM appliances AS a, statistics AS s WHERE a.macaddress = s.macaddress;", oDBConn)
            oDBReader = oDBCmd.ExecuteReader
            If oDBReader.HasRows Then
                While oDBReader.Read
                    sMACAddr = oDBReader("macaddress")
                    If sMACAddr <> "XXXXXXXXXXXXXXXX" Then
                        sAppliance = oDBReader("description")
                        oDBCmd = New OleDbCommand("SELECT TOP 1 powerusage FROM statistics WHERE macaddress='" & sMACAddr & "'  ORDER BY lastupdate DESC;", oDBConn)
                        lActual = oDBCmd.ExecuteScalar()
                        drRow = dtAppliances.NewRow()
                        drRow.Item("Appliance") = sAppliance
                        drRow.Item("Actual") = lActual
                        dtAppliances.Rows.Add(drRow)
                    End If
                End While
            End If
            oDBReader.Close()
            oDBConn.Close()

            dataView = New DataView(dtAppliances)
            dataView.Sort = "Appliance"

            ' Insert dynamic data
            For Each drvView In dataView
                sAppliance = drvView("Appliance").ToString
                sActual = String.Format("{0:n}", CSng(drvView("Actual") / 100).ToString).Replace(",", ".")
                myXAML = myXAML + "<vc:DataPoint AxisXLabel=""" & sAppliance & """ YValue=""" & sActual & """ ToolTipText=""#AxisXLabel: #YValue W"" />" + vbNewLine
            Next drvView

            myXAML = myXAML + "</vc:DataSeries.DataPoints>" + vbNewLine
            myXAML = myXAML + "</vc:DataSeries>" + vbNewLine
            myXAML = myXAML + "</vc:Chart.Series>" + vbNewLine
            myXAML = myXAML + "</vc:Chart>" + vbNewLine
        Else
            myXAML = myXAML + "Download the components from <a ref=""http://www.visifire.com"">www.visifire.com</A>" + vbNewLine
            myXAML = myXAML + "and install the components in the Plugwise html directory.<br /><br />" + vbNewLine
        End If
        
        ' Clear all response text
        Response.Clear()
    
        ' Write data xaml as response text
        Response.Write(myXAML)
    End If
%>

